<?php
class sysuser_data_user_addrs
{
	public $addrLimit = 20;

	/**
	*会员收货地址保存
	* @param $data
	* @return true or false
	*/
	public function saveAddrs($data)
	{
		$userMdlAddr = app::get('sysuser')->model('user_addrs');
		$userId = $data['user_id'];

		if(!$this->checkAddrPost($data,$userId))
		{
			return false;
		}

		return $userMdlAddr->saveAddrs($data);
	}

	/**
	*会员收货地址获取
	* @param $userId
	* @return array $userAddrs
	*/
	public function getListUserAddrs($userId)
	{
		$userMdlAddr = app::get('sysuser')->model('user_addrs');
		if( !$userId ) return false;

		$userAddrs = $userMdlAddr->getList('*',array('user_id'=>$userId));
		return $userAddrs;
	}
	/**
	*会员总收货地址
	* @param $userId
	* @return array $useraddrcount
	*/
	public function getAddrCount($userId)
	{
		$userMdlAddr = app::get('sysuser')->model('user_addrs');
		if( !$userId ) return false;
		$Count = $userMdlAddr->count(array('user_id'=>$userId));
		$userAddrCount = array(
			'nowcount'=>$Count,
			'maxcount'=>$this->addrLimit
		);
		return $userAddrCount;
	}

	/**
	*编辑会员收货地址
	* @param $userId
	* @return array $useraddrcount
	*/
	public function getAddrInfo($userId,$addrId)
	{
		$userMdlAddr = app::get('sysuser')->model('user_addrs');
		if( !$userId || !$addrId) return false;
		$addrInfo = $userMdlAddr->getRow('*',array('user_id'=>$userId,'addr_id'=>$addrId));

		return $addrInfo;
	}

	/**
	*会员默认收货地址
	* @param $userId
	* @return array $useraddrcount
	*/
	public function getDefAddr($userId)
	{
		$userMdlAddr = app::get('sysuser')->model('user_addrs');
		if( !$userId ) return false;
		$defAddr = $userMdlAddr->getRow('*',array('user_id'=>$userId,'def_addr'=>1));

		return $defAddr;
	}

	/**
	*默认收货地址设置
	* @param $arrPost
	* @param $userId
	* @return true or false
	*/

	public function setDefAddr($userId,$addrId)
	{
		$userMdlAddr = app::get('sysuser')->model('user_addrs');
		if( !$userId || !$addrId) return false;
		$addInfo = $this->getAddrInfo($userId,$addrId);
		$addInfo['def_addr'] = 1;
		return $userMdlAddr->saveAddrs($addInfo);
	}

	/**
	*删除收货地址
	* @param $addr_id
	* @param $userId
	* @return true or false
	*/

	public function delAddr($userId,$addrId)
	{
		$userMdlAddr = app::get('sysuser')->model('user_addrs');
		if( !$userId || !$addrId) return false;
		$filter = array(
			'user_id'=>$userId,
			'addr_id'=>$addrId,
		);
		return $userMdlAddr->delete($filter);
	}



	/**
	*会员收货地址检查
	* @param $data
	* @return true or false
	*/

	public function checkAddrPost($arrPost,$userId)
	{
		$userMdlAddr = app::get('sysuser')->model('user_addrs');
		if( empty($arrPost) || empty($userId) )
		{
			throw new \LogicException(app::get('sysuser')->_('缺少参数'));
			return false;
		}

		if(is_null($arrPost['area']))
		{
			throw new \LogicException(app::get('sysuser')->_('收货地区未选择'));
			return false;
		}

		if(is_null($arrPost['addr']))
		{
			throw new \LogicException(app::get('sysuser')->_('会员街道地址必填'));
			return false;
		}

		if(is_null($arrPost['name']))
		{
			throw new \LogicException(app::get('sysuser')->_('收货人姓名未填写'));
			return false;
		}

		if($arrPost['mobile'] && !preg_match("/^1[34578]{1}[0-9]{9}$/",$arrPost['mobile']))
		{
			throw new \LogicException(app::get('sysuser')->_('手机号码格式不正确'));
			return false;
		}

		if($arrPost['tel'] && !preg_match("/^(0?(([1-9]\d)|([3-9]\d{2}))-?)?\d{7,8}$/",$arrPost['tel']))
		{
			throw new \LogicException(app::get('sysuser')->_('固定电话格式不正确'));
			return false;
		}

		if(is_null($arrPost['mobile']) && is_null($arrPost['tel']))
		{
			throw new \LogicException(app::get('sysuser')->_('手机号码和固定电话至少填写一个'));
			return false;
		}

		if($arr_post['addr_id'] && !$userMdlAddr->getList('addr_id',array('addr_id'=>$arrPost['addr_id'],'user_id'=>$userId)))
		{
			throw new \LogicException(app::get('sysuser')->_('更新的收货信息不存在'));
			return false;
		}

		return true;
	}
}
